/*  gradient(): A surface to dither an internal color to an outside 
    color from  inside to edge */

surface
gradient(float Ka          = 1, 
               Kd          = 0, 
               Ks          = 0, 
               roughness   = 0.1,
               attenuation = 1;
         color insidecolor = 1,
               outsidcolor = 1
     )  
{
          point V  = normalize(-I), 
          NN = normalize(N),
          II = normalize(I),
          NF = faceforward( normalize(N), I);

    float Red , Green, Blue,
          falloff = II.NN;  /* Direct incidence has cosine closer to 1.*/
    float Start_Red, Start_Green, Start_Blue, End_Red, End_Green, End_Blue;
    color inc, outc;
    color Explode_color;
    
/* Normalize falloff by lengths of I and N */
        
    if (falloff < 0) {              /* Back of sphere only */
        falloff = falloff * falloff / (II.II * NN.NN) ;
        falloff = pow(falloff, attenuation);
        falloff = 1-falloff; 
        
        /* Reverse falloff range from 1:0 to 0:1 and
           fit falloff to colors Start and End (or End and Start) */     
     
     /* break up inside and outside colors, and determine value orientation*/
     inc=insidecolor; outc=outsidcolor;
     Start_Red=comp(inc,0); Start_Green=comp(inc,1); Start_Blue=comp(inc,2);
     End_Red=comp(outc,0); End_Green=comp(outc,1); End_Blue=comp(outc,2);
        
        if ( End_Red > Start_Red) {
            Red = clamp( falloff, Start_Red, End_Red);
        }else{
            Red = clamp( 1-falloff, End_Red, Start_Red);
        }
        if ( End_Green > Start_Green){    
            Green = clamp ( falloff, Start_Green, End_Green);
        }else{    
            Green = clamp ( 1-falloff, End_Green, Start_Green);
        }    
        if ( End_Blue > Start_Blue){    
            Blue = clamp ( falloff, Start_Blue, End_Blue);
        }else{    
            Blue = clamp ( 1-falloff, End_Blue, Start_Blue);
        }

/* Paste Explode_color outward onto object */    
    
        Explode_color = color( Red, Green, Blue);
        Ci = Explode_color * (Ka*ambient() + Kd*diffuse(NF))+(Ks*specular(NF,V,roughness));
        Oi = Os;
     }else 
Oi = 0;
}
