/* inverseglow(): a shader for providing an inverse (1-falloff) 
            centered "glow" in a sphere 
 */
surface
inverseglow( float    Ka= 0.3,
                Kd= 0.1,
                Ks= 1,
                roughness = 0.025,
                attenuation = 4;
       color    specularcolor = 1
     )    /* Previously = 2 */

{
        point NF = faceforward( normalize(N), I);
        point V  = normalize(-I); 
        point NN = normalize(N);
        point II = normalize(I);
        float falloff = II.NN;  /* Direct incidence has cosine closer to 1.*/

        
        if (falloff < 0) {              /* Back of sphere only */
                /* Normalize falloff by lengths of I and N */
                falloff = falloff * falloff / (II.II * NN.NN) ;
                falloff = pow(falloff, attenuation);
                Ci = ((Ka * ambient()) + (Kd*diffuse(NF))) * Cs *( 1-falloff);
                Ci+= specularcolor*Ks*specular(NF,V,roughness);
                Oi = 1 - falloff;
        } else
                Oi = 0;
}
  
